From cabdeea18cf31164cb6ab66f23c773a535accaa7 Mon Sep 17 00:00:00 2001
From: Benjamin Dauvergne <bdauvergne@entrouvert.com>
Date: Thu, 13 Nov 2014 16:57:26 +0100
Subject: [PATCH 5/5] Update french translations (refs #5925)

---
 authentic2/idp/locale/fr/LC_MESSAGES/django.po |   96 +-------
 authentic2/locale/fr/LC_MESSAGES/django.po     |  281 ++++++++++++++++--------
 2 files changed, 187 insertions(+), 190 deletions(-)

diff --git a/authentic2/idp/locale/fr/LC_MESSAGES/django.po b/authentic2/idp/locale/fr/LC_MESSAGES/django.po
index 80b72bc..25eb4ed 100644
--- a/authentic2/idp/locale/fr/LC_MESSAGES/django.po
+++ b/authentic2/idp/locale/fr/LC_MESSAGES/django.po
@@ -7,8 +7,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Authentic\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2014-07-04 16:00+0200\n"
-"PO-Revision-Date: 2014-08-19 10:15+0200\n"
+"POT-Creation-Date: 2014-11-13 16:57+0100\n"
+"PO-Revision-Date: 2014-11-13 16:57+0100\n"
 "Last-Translator: Mikaël Ates <mates@entrouvert.com>\n"
 "Language-Team: None\n"
 "Language: fr\n"
@@ -78,95 +78,3 @@ msgstr "règlement sur les attributs"
 #: models.py:109
 msgid "attribute policies"
 msgstr "règlements sur les attributs"
-
-#: templates/idp/account_management.html:5
-msgid "Authentic - Account Management"
-msgstr "Authentic - Gestion du compte"
-
-#: templates/idp/account_management.html:10 templates/idp/homepage.html:13
-msgid "Account Management"
-msgstr "Gestion de votre compte"
-
-#: templates/idp/account_management.html:11
-msgid "Profile"
-msgstr "Profil"
-
-#: templates/idp/account_management.html:28
-msgid "Change email"
-msgstr "Modifier votre adresse électronique"
-
-#: templates/idp/account_management.html:29
-msgid "Edit profile"
-msgstr "Éditer votre profil"
-
-#: templates/idp/account_management.html:30
-msgid "Delete profile"
-msgstr "Supprimer votre profil"
-
-#: templates/idp/account_management.html:32
-msgid "Credentials"
-msgstr "Moyens d'authentification"
-
-#: templates/idp/account_management.html:36
-msgid "Back"
-msgstr "Retour"
-
-#: templates/idp/homepage.html:5
-msgid "Authentic"
-msgstr "Authentic"
-
-#: templates/idp/homepage.html:20
-msgid "Services"
-msgstr "Services"
-
-#: templates/idp/homepage.html:50
-msgid "Administration"
-msgstr "Administration"
-
-#: templates/idp/logout.html:5
-msgid "Logout"
-msgstr "Déconnexion"
-
-#: templates/idp/logout.html:40
-msgid "Continue logout"
-msgstr "Continuer la déconnexion"
-
-#: templates/interaction/consent_attributes.html:4
-msgid "Consent page for attribute propagation"
-msgstr "Page de consentement pour la transmission des attributs"
-
-#: templates/interaction/consent_attributes.html:14
-msgid "Choose attributes to send to "
-msgstr "Choisissez les attributs à envoyer"
-
-#: templates/interaction/consent_attributes.html:31
-msgid "Send selected"
-msgstr "Envoyer la selection"
-
-#: templates/interaction/consent_attributes.html:33
-msgid "Send all"
-msgstr "Tout envoyer"
-
-#: templates/interaction/consent_attributes.html:35
-msgid "Refuse all"
-msgstr "Aucun"
-
-#: templates/interaction/consent_federation.html:4
-msgid "Consent page for federation"
-msgstr "Page de consentement pour la fédération"
-
-#: templates/interaction/consent_federation.html:13
-msgid "Do you accept to federate your account with "
-msgstr "Acceptez-vous de fédérer votre compte avec "
-
-#: templates/interaction/consent_federation.html:15
-msgid "Do you accept to federate your account ?"
-msgstr "Acceptez-vous de federez vos comptes ?"
-
-#: templates/interaction/consent_federation.html:23
-msgid "Accept"
-msgstr "Accepter"
-
-#: templates/interaction/consent_federation.html:24
-msgid "Refuse"
-msgstr "Refuser"
diff --git a/authentic2/locale/fr/LC_MESSAGES/django.po b/authentic2/locale/fr/LC_MESSAGES/django.po
index 2f94100..c406171 100644
--- a/authentic2/locale/fr/LC_MESSAGES/django.po
+++ b/authentic2/locale/fr/LC_MESSAGES/django.po
@@ -7,8 +7,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Authentic\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2014-10-20 09:13+0200\n"
-"PO-Revision-Date: 2014-10-28 12:31+0100\n"
+"POT-Creation-Date: 2014-11-13 16:55+0100\n"
+"PO-Revision-Date: 2014-11-13 16:56+0100\n"
 "Last-Translator: Mikaël Ates <mates@entrouvert.com>\n"
 "Language-Team: None\n"
 "Language: fr\n"
@@ -30,7 +30,7 @@ msgstr "adresses IP"
 msgid "deleted user %r"
 msgstr "utilisateur supprimé %r"
 
-#: admin.py:91 models.py:31 models.py:41
+#: admin.py:91 models.py:88 models.py:188 models.py:198
 msgid "user"
 msgstr "utilisateur"
 
@@ -70,13 +70,13 @@ msgstr "Dates importantes"
 msgid "Attributes"
 msgstr "Attributs"
 
-#: app_settings.py:105
+#: app_settings.py:112
 msgid "Required. At most 30 characters. Letters, digits, and @/./+/-/_ only."
 msgstr ""
 "Requis. 30 caractères maximum. Uniquement des lettres, nombres et les "
 "caractères « @ », « . », « + », « - » et « _ »."
 
-#: app_settings.py:107
+#: app_settings.py:114
 msgid "Username"
 msgstr "Identifiant"
 
@@ -154,7 +154,7 @@ msgstr ""
 "Requis. %s caractères maximum. Uniquement des lettres, nombres et les "
 "caractères « @ », « . », « + », « - » et « _ »."
 
-#: fix_user_model.py:37
+#: fix_user_model.py:37 models.py:66
 msgid "username"
 msgstr "Identifiant"
 
@@ -166,7 +166,7 @@ msgstr "Nouveau courriel"
 msgid "Incorrect password."
 msgstr "Mot de passe incorrect."
 
-#: forms.py:119
+#: forms.py:119 models.py:89
 msgid "users"
 msgstr "utilisateurs"
 
@@ -190,72 +190,105 @@ msgstr "condensé"
 msgid "Dashboard"
 msgstr "Tableau de bord"
 
-#: models.py:33 models.py:47
+#: models.py:67
+msgid ""
+"Required. 30 characters or fewer. Letters, numbers and @/./+/-/_ characters"
+msgstr ""
+"Requis. 30 caractères maximum. Uniquement des lettres, des nombres et les "
+"caractères « @ », « . », « + », « - » et « _ »."
+
+#: models.py:70
+msgid "Enter a valid username."
+msgstr "Entrez un identifiant correct."
+
+#: models.py:72
+msgid "staff status"
+msgstr ""
+
+#: models.py:73
+msgid "Designates whether the user can log into this admin site."
+msgstr ""
+
+#: models.py:75
+msgid "active"
+msgstr ""
+
+#: models.py:76
+msgid ""
+"Designates whether this user should be treated as active. Unselect this "
+"instead of deleting accounts."
+msgstr ""
+
+#: models.py:78
+msgid "date joined"
+msgstr ""
+
+#: models.py:190 models.py:204
 msgid "creation date"
 msgstr "date de création"
 
-#: models.py:36
+#: models.py:193
 msgid "user to delete"
 msgstr "utilisateur à effacer"
 
-#: models.py:37
+#: models.py:194
 msgid "users to delete"
 msgstr "utilisateurs à effacer"
 
-#: models.py:43
+#: models.py:200
 msgid "source"
 msgstr ""
 
-#: models.py:45
+#: models.py:202
 msgid "external id"
 msgstr "identifiant externe"
 
-#: models.py:49
+#: models.py:206
 msgid "last update date"
 msgstr "dernière date de mise à jour"
 
-#: models.py:62
+#: models.py:219
 msgid "user external id"
 msgstr "identifiant externe d'un utilisateur"
 
-#: models.py:63
+#: models.py:220
 msgid "user external ids"
 msgstr "identifiants externes des utilisateurs"
 
-#: models.py:68
+#: models.py:225
 msgid "when"
 msgstr "quand"
 
-#: models.py:70
+#: models.py:227
 msgid "who"
 msgstr "qui"
 
-#: models.py:72
+#: models.py:229
 msgid "how"
 msgstr "comment"
 
-#: models.py:74
+#: models.py:231
 msgid "nonce"
 msgstr "numéro unique"
 
-#: models.py:79
+#: models.py:236
 msgid "authentication log"
 msgstr "Journal des authentifications"
 
-#: models.py:80
+#: models.py:237
 msgid "authentication logs"
 msgstr "Journaux des authentification"
 
-#: models.py:83
+#: models.py:240
 #, python-format
 msgid "Authentication of %(who)s by %(how)s at %(when)s"
 msgstr "Authentification de %(who)s par %(how)s à %(when)s"
 
-#: models.py:87
+#: models.py:244
 msgid "url"
 msgstr ""
 
-#: models.py:87
+#: models.py:244
 msgid ""
 "you can use a {} to pass the URL of the success icon, ex.: http://example."
 "com/logout?next={}"
@@ -263,15 +296,15 @@ msgstr ""
 "vous pouvez utiliser la chaîne {} pour passer l'URL de l'icône de succès,  "
 "ex.: http://example.com/logout?next={}"
 
-#: models.py:91
+#: models.py:248
 msgid "use an iframe instead of an img tag for logout"
 msgstr "utiliser une iframe au lieu d'un tag img pour la déconnexion"
 
-#: models.py:93
+#: models.py:250
 msgid "iframe logout timeout (ms)"
 msgstr "temps d'expiration pour les iframe de déconnexion (en ms)"
 
-#: models.py:94
+#: models.py:251
 msgid ""
 "if iframe logout is used, it's the time between the onload event for this "
 "iframe and the moment we consider its loading to be really finished"
@@ -280,103 +313,103 @@ msgstr ""
 "l'évènement onload pour cette iframe et le moment où l'on peut considérer "
 "que le chargement vraiment terminé."
 
-#: models.py:110 models.py:203
+#: models.py:267 models.py:360
 msgid "content type"
 msgstr "type d'objet"
 
-#: models.py:112 models.py:205
+#: models.py:269 models.py:362
 msgid "object identifier"
 msgstr "identifiant d'objet"
 
-#: models.py:116 models.py:117
+#: models.py:273 models.py:274
 msgid "logout URL"
 msgstr "URL de déconnexion"
 
-#: models.py:121
+#: models.py:278
 msgid "provider"
 msgstr "fournisseur"
 
-#: models.py:123
+#: models.py:280
 msgid "about"
 msgstr "à propos"
 
-#: models.py:125
+#: models.py:282
 msgid "service"
 msgstr ""
 
-#: models.py:127
+#: models.py:284
 msgid "format identifier"
 msgstr "identifiant du format"
 
-#: models.py:129
+#: models.py:286
 msgid "identifier"
 msgstr "identifiant"
 
-#: models.py:134
+#: models.py:291
 msgid "federation identifier"
 msgstr "identifiant de fédération"
 
-#: models.py:135
+#: models.py:292
 msgid "federation identifiers"
 msgstr "identifiants de fédération"
 
-#: models.py:138
+#: models.py:295
 msgid "label"
 msgstr "label"
 
-#: models.py:140
+#: models.py:297
 msgid "description"
 msgstr ""
 
-#: models.py:141
+#: models.py:298
 msgid "name"
 msgstr "identifiant"
 
-#: models.py:144
+#: models.py:301
 msgid "required"
 msgstr "requis"
 
-#: models.py:147
+#: models.py:304
 msgid "asked on registration"
 msgstr "demandé à l'enregistrement"
 
-#: models.py:150
+#: models.py:307
 msgid "user editable"
 msgstr "éditable par l'utilisateur"
 
-#: models.py:153
+#: models.py:310
 msgid "user visible"
 msgstr "visible de l'utilisateur"
 
-#: models.py:156
+#: models.py:313
 msgid "multiple"
 msgstr ""
 
-#: models.py:159
+#: models.py:316
 msgid "kind"
 msgstr "type"
 
-#: models.py:198
+#: models.py:355
 msgid "attribute definition"
 msgstr "définition d'un attribut"
 
-#: models.py:199
+#: models.py:356
 msgid "attribute definitions"
 msgstr "définition des attributs"
 
-#: models.py:209
+#: models.py:366
 msgid "attribute"
 msgstr "attribut"
 
-#: models.py:211
+#: models.py:368
 msgid "content"
 msgstr "contenu"
 
-#: models.py:226
+#: models.py:383
 msgid "attribute value"
 msgstr "valeur d'un attribut"
 
-#: models.py:227
+#: models.py:384
 msgid "attribute values"
 msgstr "valeurs des attributs"
 
@@ -414,7 +447,7 @@ msgstr ""
 "Le mot de passe doit contenir des caractères d'au moins %d types parmi: "
 "minuscules, majuscules, chiffres et ponctuations"
 
-#: views.py:171
+#: views.py:172
 msgid ""
 "Your request for changing your email is received. An email of validation was "
 "sent to you. Please click on the link contained inside."
@@ -423,39 +456,39 @@ msgstr ""
 "courriel de validation vous a été envoyé. Veuillez cliquer sur le lien "
 "contenu dans ce courriel."
 
-#: views.py:190
+#: views.py:192
 msgid "your request for changing your email for {0} is successful"
 msgstr "Votre demande de changement d'adresse de courriel pour {0} est validée"
 
-#: views.py:193
+#: views.py:195
 msgid "your request for changing your email is too old, try again"
 msgstr ""
 "Votre demande de changement d'adresse de courriel est trop ancienne, "
 "veuillez réessayez"
 
-#: views.py:196
+#: views.py:198
 msgid "your request for changing your email is invalid, try again"
 msgstr ""
 "Votre demande de changement d'adresse de courriel est invalide, veuillez "
 "réessayer"
 
-#: views.py:199
+#: views.py:201
 msgid "your request for changing your email was not on this site, try again"
 msgstr ""
 "Votre demande de changement d'adresse de courriel vient d'un autre site que "
 "celui-ci."
 
-#: views.py:202
+#: views.py:204
 msgid "your request for changing your email is for an unknown user, try again"
 msgstr ""
 "Votre demande de changement d'adresse de courriel concerne un utilisateur "
 "inconnu."
 
-#: views.py:396
+#: views.py:407
 msgid "Logging out from all your services"
 msgstr "Déconnexion de tous vos services"
 
-#: views.py:401 templates/registration/logout.html:9
+#: views.py:412 templates/registration/logout.html:9
 msgid "Logged out"
 msgstr "Déconnecté"
 
@@ -534,11 +567,12 @@ msgstr "Serveur de gestion d'identité versatile"
 msgid "Hello %(username)s."
 msgstr "Bonjour %(username)s"
 
-#: templates/base.html:31
+#: templates/base.html:31 templates/idp/logout.html:5
 msgid "Logout"
-msgstr "Me déconnecter"
+msgstr "Déconnexion"
 
-#: templates/error.html:8 templates/registration/logout.html:10
+#: templates/error.html:8 templates/idp/account_management.html:63
+#: templates/registration/logout.html:10
 #: templates/registration/registration_complete.html:10
 msgid "Back"
 msgstr "Retour"
@@ -630,6 +664,94 @@ msgstr ""
 msgid "Notification: %(user)s, your account has been deleted"
 msgstr ""
 
+#: templates/idp/account_management.html:5
+msgid "Authentic - Account Management"
+msgstr "Authentic - Gestion du compte"
+
+#: templates/idp/account_management.html:10 templates/idp/homepage.html:13
+msgid "Account Management"
+msgstr "Gestion de votre compte"
+
+#: templates/idp/account_management.html:11
+msgid "Profile"
+msgstr "Profil"
+
+#: templates/idp/account_management.html:29
+msgid "Change email"
+msgstr "Modifier votre adresse électronique"
+
+#: templates/idp/account_management.html:32
+msgid "Edit profile"
+msgstr "Éditer votre profil"
+
+#: templates/idp/account_management.html:35
+msgid "Delete profile"
+msgstr "Supprimer votre profil"
+
+#: templates/idp/account_management.html:38
+msgid "Credentials"
+msgstr "Moyens d'authentification"
+
+#: templates/idp/account_management.html:44
+msgid "Federation management"
+msgstr "Gestion des liaisons"
+
+#: templates/idp/homepage.html:5
+msgid "Authentic"
+msgstr "Authentic"
+
+#: templates/idp/homepage.html:20
+msgid "Services"
+msgstr "Services"
+
+#: templates/idp/homepage.html:50
+msgid "Administration"
+msgstr "Administration"
+
+#: templates/idp/logout.html:40
+msgid "Continue logout"
+msgstr "Continuer la déconnexion"
+
+#: templates/interaction/consent_attributes.html:4
+msgid "Consent page for attribute propagation"
+msgstr "Page de consentement pour la transmission des attributs"
+
+#: templates/interaction/consent_attributes.html:14
+msgid "Choose attributes to send to "
+msgstr "Choisissez les attributs à envoyer"
+
+#: templates/interaction/consent_attributes.html:31
+msgid "Send selected"
+msgstr "Envoyer la selection"
+
+#: templates/interaction/consent_attributes.html:33
+msgid "Send all"
+msgstr "Tout envoyer"
+
+#: templates/interaction/consent_attributes.html:35
+msgid "Refuse all"
+msgstr "Aucun"
+
+#: templates/interaction/consent_federation.html:4
+msgid "Consent page for federation"
+msgstr "Page de consentement pour la fédération"
+
+#: templates/interaction/consent_federation.html:13
+msgid "Do you accept to federate your account with "
+msgstr "Acceptez-vous de fédérer votre compte avec "
+
+#: templates/interaction/consent_federation.html:15
+msgid "Do you accept to federate your account ?"
+msgstr "Acceptez-vous de federez vos comptes ?"
+
+#: templates/interaction/consent_federation.html:23
+msgid "Accept"
+msgstr "Accepter"
+
+#: templates/interaction/consent_federation.html:24
+msgid "Refuse"
+msgstr "Refuser"
+
 #: templates/profiles/edit_profile.html:4
 msgid "Create profile"
 msgstr "Créer un profil"
@@ -800,36 +922,3 @@ msgstr ""
 #: templates/registration/registration_form.html:16
 msgid "Registration"
 msgstr "Enregistrement"
-
-#~ msgid "siret"
-#~ msgstr "SIRET"
-
-# already translated by django, do nothing
-#~ msgid ""
-#~ "Required. 30 characters or fewer. Letters, numbers and @/./+/-/_ "
-#~ "characters"
-#~ msgstr ""
-#~ "Requis. 30 caractères maximum. Uniquement des lettres, nombres et les "
-#~ "caractères « @ », « . », « + », « - » et « _ »."
-
-#~ msgid "Enter a valid username."
-#~ msgstr "Entrez un identifiant valide."
-
-#~ msgid "staff status"
-#~ msgstr "statut équipe"
-
-#~ msgid "Designates whether the user can log into this admin site."
-#~ msgstr "Indique si l'utilisateur peut accéder aux pages d'administration"
-
-#~ msgid "active"
-#~ msgstr "actif"
-
-#~ msgid ""
-#~ "Designates whether this user should be treated as active. Unselect this "
-#~ "instead of deleting accounts."
-#~ msgstr ""
-#~ "Indique si ce compte doit être considéré comme actif. Décochez cette case "
-#~ "plutôt que de supprimer un compte."
-
-#~ msgid "date joined"
-#~ msgstr "date de création"
-- 
1.7.10.4